=== debian/changelog ===
klatexformula (3.2.8-0ubuntu1) trusty; urgency=medium

  * New upstream release. LP: #1296902
    - fixes a bug caused by recent versions of ghostscript

 -- Jackson Doak <noskcaj@ubuntu.com>  Tue, 25 Mar 2014 07:03:05 +1100
