=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk
DEB_CMAKE_NORMAL_ARGS+=-DKLF_INSTALL_DESKTOP=TRUE -DKLF_INSTALL_KLFAPP_STATIC_LIBS=FALSE -DKLF_LIBKLFAPP_STATIC=FALSE -DKLF_LIBKLFBACKEND_STATIC=FALSE -DKLF_LIBKLFTOOLS_STATIC=FALSE -DKLF_INSTALL_APIDOC_DIR=share/doc/libklatexformula3-doc -DKLF_INSTALL_RCCRESOURCES_DIR=lib/klatexformula/rccresources -DKLF_INSTALL_LIB_DIR=lib
build/klatexformula::
		/usr/bin/docbook-to-man debian/klatexformula.1.sgml > debian/klatexformula.1

clean/klatexformula::
	rm Doxyfile.klftools
	rm Doxyfile.klfapp
	rm welcome_installer_withlatex.txt
	rm Doxyfile.klfbackend.sfweb
	rm Doxyfile.klfapp.sfweb
	rm cmake_uninstall.cmake
	rm klf_test_condition.cmake
	rm Doxyfile.klftools.sfweb
	rm klf_test_condition.cmake.in
	rm cmake_uninstall_script.cmake
	rm Doxyfile.klftools
	rm Doxyfile.klfbackend
	rm welcome_installer.txt
	rm src/klf_xtradata.qrc
	rm src/klatexformula.desktop
	rm src/plugins/info_baseplugins.xml
	rm src/plugins/plugindirinfo.xml
	rm src/plugins/klfbaseplugins.qrc
	rm src/klfkateplugin/ktexteditor_klf_automoc.cpp.files
