=== debian/watch ===
version=3

http://sf.net/klatexformula/klatexformula-(\d.*)\.tar.gz
